#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <time.h>

#include "file_selection.h"
#include "list_int_addr.h"
#include "about.h"
#include "international.h"
#include "layouts.h"

#define ADD_ROW		gtk_list_store_append (GTK_LIST_STORE(command_info_table), &iter);

#define ADD_ROW2	gtk_list_store_append (GTK_LIST_STORE(l2elem->table), &l2elem->iter);

#define FILL_ROW	gtk_list_store_set (command_info_table, &iter, \
							0, tcp[0], 1, tcp[1], 2, tcp[2], 3, tcp[3], \
							4, tcp[4], 5, tcp[5], 6, tcp[6], 7, tcp[7], \
							8, tcp[8], 9, tcp[9], 10, tcp[10], 11, tcp[11], \
							-1);
							
#define FILL_ROW2	gtk_list_store_set (l2elem->table, &l2elem->iter, \
							0, tcp[1], 1, tcp[2], 2, tcp[3], 3, tcp[4], \
							4, tcp[5], 5, tcp[6], 6, tcp[7], 7, tcp[8], \
							8, tcp[9], 9, tcp[10], 10, tcp[11], -1);


/* autorefresh */
extern guint timeout_id;

/* interface */
extern GtkWidget *save_at_refresh1;
extern GtkWidget *statusbar;
extern gchar *commands_lsof;
extern gchar *path;
extern gboolean first_save_at_refresh_call;

/* layouts */
extern GtkListStore *liststore_left_command_column;
extern GtkListStore *command_info_table;
extern GtkWidget *vbox_right_panel_side;
extern GtkWidget *view_left_command_column;
extern guint temp_l2elem_selected;
extern gchar *name_fields[];
extern GtkWidget *hpaned;

/* settings */
extern gboolean tmp_radio_buts[6];
extern gboolean tmp_check_buts[17];
extern gchar *tmp_entry_buts[7];

/* list_int_addr */
extern GPtrArray *tmp_add_list;

/* configuration */
extern gboolean tmp_check_show_splash_conf;

/* view_options */
extern gboolean state_fields[12];

/* local */
static guint timeout_splash_window = 0;
static GtkWidget *splash_window = NULL;
static gchar *tcp[12];
static layout2_elem *l2elem = NULL;

guint append_num;
GPtrArray *list_command_name;
GPtrArray *list_layout2_table;
gint num_command = 0;


/************************************/
/*      CONTROL FOR SETTINGS        */
/************************************/

static void
control_settings (void)
{

  commands_lsof = " ";
	
/**************/
/*   PAGE 0   */
/**************/

/* -l */
  if (tmp_radio_buts[0])
    commands_lsof = g_strconcat (commands_lsof, " -l ", NULL);

/* -o -s */
  if (tmp_radio_buts[1])
    commands_lsof = g_strconcat (commands_lsof, " -o ", NULL);
  else
    commands_lsof = g_strconcat (commands_lsof, " -s ", NULL);

/* -a */
  if (tmp_check_buts[0])
    commands_lsof = g_strconcat (commands_lsof, " -a ", NULL);


/**************/
/*   PAGE 1   */
/**************/

/* -c */
  if (tmp_check_buts[1])
    commands_lsof = g_strconcat (commands_lsof, " -c ", 
  g_strjoinv (" -c ", g_strsplit (tmp_entry_buts[0], ",", -1)), NULL);

/* -p */
  if (tmp_check_buts[2])
    commands_lsof =
      g_strconcat (commands_lsof, " -p ", tmp_entry_buts[1], NULL);

/* -g */
  if (tmp_check_buts[3])
    commands_lsof =
      g_strconcat (commands_lsof, " -g ", tmp_entry_buts[2], NULL);


/**************/
/*   PAGE 2   */
/**************/

/* +d +D */
  if (tmp_check_buts[4])
    {
      if (tmp_check_buts[8])
	commands_lsof =
	  g_strconcat (commands_lsof, " +D ", tmp_entry_buts[3], NULL);
      else
	commands_lsof =
	  g_strconcat (commands_lsof, " +d ", tmp_entry_buts[3], NULL);
    }

/* -d */
  if (tmp_check_buts[5])
    {
      if (tmp_radio_buts[4])
	commands_lsof =
	  g_strconcat (commands_lsof, " -d ", tmp_entry_buts[4], NULL);
      else
	commands_lsof = g_strconcat (commands_lsof, " -d ^", 
	  g_strjoinv (",^", g_strsplit (tmp_entry_buts[4], ",", -1)), NULL);
    }

/* -u */
  if (tmp_check_buts[6])
    commands_lsof =
      g_strconcat (commands_lsof, " -u ", tmp_entry_buts[5], NULL);

/* +L */
  if (tmp_check_buts[7])
    commands_lsof =
      g_strconcat (commands_lsof, " +L ", tmp_entry_buts[6], NULL);


/**************/
/*   PAGE 3   */
/**************/

/* -i */
  if (tmp_check_buts[9])
  {
	  int i=0;
	  node_data *elem;
	  
	  if (tmp_add_list->len == 0)
		  commands_lsof = g_strconcat (commands_lsof, " -i ", NULL);
	  
	  else 		  
		  while (i < tmp_add_list->len)
		  {
			  elem = g_ptr_array_index(tmp_add_list, i);
			  commands_lsof = g_strconcat (commands_lsof, " -i ", elem->option, NULL);
			  i++;
		  }
  }

/* -n */
  if (tmp_check_buts[10])
    commands_lsof = g_strconcat (commands_lsof, " -n ", NULL);

/* -N */
  if (tmp_check_buts[11])
    commands_lsof = g_strconcat (commands_lsof, " -N ", NULL);

/* -P */
  if (tmp_check_buts[12])
    commands_lsof = g_strconcat (commands_lsof, " -P ", NULL);

/* -U */
  if (tmp_check_buts[13])
    commands_lsof = g_strconcat (commands_lsof, " -U ", NULL);


/**************/
/*   PAGE 4   */
/**************/

/* -S */
  if (tmp_check_buts[14])
    commands_lsof =
      g_strconcat (commands_lsof, " -S ", tmp_entry_buts[7], NULL);

/* -b */
  if (tmp_check_buts[15])
    commands_lsof = g_strconcat (commands_lsof, " -b ", NULL);
}

/************************************/
/*      	MAKE SPLASH WINDOW        */
/************************************/

static
void make_splash_window(void)
{
	GtkWidget *vbox;
	GdkPixbuf* pixbuf;
	GtkWidget *image;
	GtkWidget *label;
	GdkColor color;
	
	splash_window = gtk_window_new (GTK_WINDOW_POPUP);
	gtk_window_set_position (GTK_WINDOW (splash_window), GTK_WIN_POS_CENTER);
    gtk_window_set_decorated(GTK_WINDOW(splash_window), FALSE);
    gtk_window_set_resizable(GTK_WINDOW(splash_window),FALSE);
	color.red = 65535;
    color.blue = 65535;
    color.green = 65535;
    gtk_widget_modify_bg(splash_window, GTK_STATE_NORMAL,&color);

	vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(splash_window), vbox);
	gtk_widget_show(vbox);

	gtk_widget_realize(splash_window);
	gdk_window_set_decorations(splash_window->window, 0);
	
	pixbuf = gdk_pixbuf_new_from_file(PACKAGE_DATA_DIR "/glsof/pixmaps/logo.png", NULL);
	image = gtk_image_new_from_pixbuf(pixbuf);
	gtk_container_add (GTK_CONTAINER (vbox), image);
	g_object_unref(pixbuf);	
	gtk_widget_show(image);
	
	label = gtk_label_new(_("please wait, glsof at work..."));
	gtk_container_add (GTK_CONTAINER (vbox), label);
    gtk_widget_show(label);
		
	gtk_widget_show(splash_window);
	
	while(g_main_context_pending(NULL) || !GTK_WIDGET_REALIZED(image))
		gtk_main_iteration();
}

/************************************/
/*      CLOSE SPLASH WINDOW         */
/************************************/

static gboolean
close_splash_window (gpointer data)
{
	gtk_timeout_remove (timeout_splash_window);
	gtk_widget_destroy(splash_window);
	splash_window = NULL;
		
	return TRUE;
}

/***************************************/
/* check for command list append names */
/***************************************/

static void
new_layout2_table (layout2_elem *elem)
{
  GtkTreeSelection *selection;
  GtkCellRenderer *cell;
  GtkTreeViewColumn *column;
	
  int i = 0;

  /* scrolled window for main list */
  
  elem->lines = 0;
  elem->scrolledwindow = gtk_scrolled_window_new (NULL, NULL);

  gtk_container_add (GTK_CONTAINER (vbox_right_panel_side), elem->scrolledwindow);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (elem->scrolledwindow),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (elem->scrolledwindow),
				       GTK_SHADOW_OUT);
					   
  /* make main column-list */
  
  elem->view = gtk_tree_view_new ();
  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (elem->view));

  gtk_tree_selection_set_mode (selection, GTK_SELECTION_SINGLE);
  elem->table = gtk_list_store_new (11, \
  			G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, \
			G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, \
			G_TYPE_STRING);

  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (elem->view), TRUE);	/* white - grey alternate */
  
  gtk_tree_view_set_model (GTK_TREE_VIEW (elem->view), GTK_TREE_MODEL (elem->table));

  
  for (i = 0; i < 11; i++)
    {
		cell = gtk_cell_renderer_text_new ();
		column = gtk_tree_view_column_new_with_attributes(name_fields[i+1], cell, "text", i, NULL);
		gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);
		gtk_tree_view_column_set_visible (column, state_fields[i+1]);
		
		if (i==10)
			gtk_tree_view_column_set_sort_column_id(column, i);
		
		gtk_tree_view_append_column(GTK_TREE_VIEW(elem->view), column);
	}
	
  gtk_widget_show (elem->view);
  gtk_container_add (GTK_CONTAINER (elem->scrolledwindow), elem->view);
	
  return;
}

static void
chk_command_list_add_row (void)
{
  GtkTreeIter iter_command_list;
  gint i;
  gpointer elem;
  gboolean make_new_element = TRUE;

  
  for (i=0; i < list_command_name->len; i++)
  	if ( g_ascii_strcasecmp ( g_ptr_array_index(list_command_name, i), tcp[0]) == 0 )
	{
		make_new_element = FALSE;
		l2elem = g_ptr_array_index (list_layout2_table, i);
		break;
		//return;
	}

  if (make_new_element == TRUE)
  {
	  /* new table for single command */

	  l2elem = g_malloc (sizeof(layout2_elem));
	  new_layout2_table (l2elem); /* fill fields */
	  g_ptr_array_add (list_layout2_table, (gpointer) l2elem);
		
	  /* add command on left table */
		
	  elem = g_malloc (strlen (tcp[0]));
	  elem = g_strdup (tcp[0]);
	  g_ptr_array_add (list_command_name, (gpointer) elem);
	
	  num_command++;
	  gtk_list_store_append (GTK_LIST_STORE (liststore_left_command_column), &iter_command_list);
	  gtk_list_store_set (liststore_left_command_column, &iter_command_list, 0, num_command, 1, elem, -1);
   }
	
   l2elem->lines++;
   ADD_ROW2
}

static void
chk_command_list_clear (void)
{
	gint i;
	layout2_elem *tmp_elem;
	
	for (i=list_command_name->len-1; i>=0; i--)
  {
	  tmp_elem = g_ptr_array_index (list_command_name, i);
	  
	  gtk_list_store_remove (tmp_elem->table,&tmp_elem->iter);
	  
	  g_ptr_array_remove_index (list_command_name, i);
	  g_free (tmp_elem);
  }
  /* freedom for everythings */
	
  if (i>=0)
	  g_ptr_array_free (list_command_name,FALSE);
}

void
update_clist (void)
{
  gchar readbuf[BUFSIZ];
  gchar readbuf2[12][BUFSIZ];
  gchar readbuf3[12][BUFSIZ];
  gchar *lsof_info[12];
  gchar *tmp2;
  gchar **filter_argv;
	
  gchar fd[10];
	
  gint mod = 1000;
  gint width[12];

  gboolean print = FALSE;
  //gboolean repeat = FALSE;
  
  GtkTreeIter iter;
  
  gint i,j;
  gint output=0;
  FILE *fp;
  
  /* show splash window */
  
  if (tmp_check_show_splash_conf == FALSE)
  {
	  if (splash_window != NULL)
		  gtk_timeout_remove (timeout_splash_window);
	  else
		  make_splash_window();
  }
  
  /* free list_command_name */
  
  temp_l2elem_selected = 0;
  
  chk_command_list_clear ();
  
  /* start settings for control */
  
  append_num = 0;
  commands_lsof = NULL;
  
  control_settings ();
  
  tmp2 = g_malloc (strlen(commands_lsof));

  if (commands_lsof)
  {
	g_strstrip(commands_lsof);
	  
	i=1;
	j=1;
	tmp2 [0] = commands_lsof[0];
	  
	  while (commands_lsof[i])
	  {
		  if (!((commands_lsof[i]==' ') && (commands_lsof[i-1]==' ')))
		  tmp2 [j++] = commands_lsof[i];
		  i++;
	  }
	  
	  tmp2 [j] = 0;
      commands_lsof = g_strconcat (path, tmp2, NULL);
  }
  else
    commands_lsof = g_strdup (path);
  
  printf ("########### %s\n", commands_lsof);
  
  filter_argv = g_strsplit (commands_lsof," ", -1);
  
  g_free (commands_lsof);
  g_free (tmp2);
  
  memset (fd, 0, sizeof (fd));
  memset (readbuf2, 0, sizeof (readbuf2));
  memset (readbuf3, 0, sizeof (readbuf3));
  
  for (i = 0; i < 12; i++)
    {
      lsof_info[i] = readbuf2[i];
      tcp[i] = readbuf3[i];
      width[i] = 0;
    }

  g_spawn_async_with_pipes (NULL,filter_argv,NULL,0,NULL,NULL,NULL,NULL,&output,NULL,NULL);	
  fp = fdopen (output, "r");
  g_strfreev (filter_argv);

	
  while (fgets (readbuf, BUFSIZ, fp))
    {
      //repeat = FALSE;

      switch (readbuf[0])
	{

	case 'c':
	  {
	    mod = 0;
	    break;
	  }			/* COMMAND */
	case 'p':
	  {
	    mod = 1;
	    break;
	  }			/* PID */
	case 'g':
	  {
	    mod = 2;
	    break;
	  }			/* PGID */
	case 'R':
	  {
	    mod = 3;
	    break;
	  }			/* PPID */

	case 'u':
	  {
	    mod = 4;
	    break;
	  }			/* USER */
	case 'L':
	  {
	    mod = 4;
	    break;
	  }

	case 'f':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }			/* FD */
	case 'a':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }
	case 'l':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }

	case 't':
	  {
	    mod = 6;
	    break;
	  }			/* TYPE */

	case 'd':
	  {
	    mod = 7;
	    break;
	  }			/* DEVICE */
	case 'D':
	  {
	    mod = 7;
	    break;
	  }

	case 'o':
	  {
	    mod = 8;
	    break;
	  }			/* SIZE/OFF */
	case 's':
	  {
	    mod = 8;
	    break;
	  }

	case 'k':
	  {
	    mod = 9;
	    break;
	  }			/* NLINK */

	case 'i':
	  {
	    mod = 10;
	    break;
	  }			/* NODE */
	case 'P':
	  {
	    mod = 10;
	    break;
	  }

	case 'S':
	  {
	    mod = 11;
	    print = TRUE;
	    break;
	  }			/* NAME */
	case 'n':
	  {
	    mod = 11;
	    print = TRUE;
	    break;
	  }
	case 'T':
	  {
		strcat (tcp[11], "(");
	    strncat (tcp[11], &readbuf[1], strlen (readbuf) - 2);
		strcat (tcp[11], ")");
	    //repeat = TRUE;
	    break;
	  }

	default:
	  mod = 1000;
	}

      if (mod < 1000 && ((strlen (readbuf) - 2) > width[mod]))
	width[mod] = strlen (readbuf) - 2;

	  if (mod < 1000 && mod != 5)
	    {
	      memset (readbuf2[mod], 0, sizeof (readbuf2[mod]));
	      strncpy (&readbuf2[mod][0], &readbuf[1], strlen (readbuf) - 2);
	      mod = 1000;
	    }

	  if (print == TRUE)
	    {
	      strncpy (&readbuf2[5][0], &fd[0], strlen (fd));
	      memset (fd, 0, sizeof (fd));
			
		  if (strlen (tcp[0])>0)
		  {
			  gboolean add_line_table = TRUE;
			  
			  if (tmp_check_buts[16])
				  if ((!strcmp (tcp[0],"glsof")) || (!strcmp (tcp[0],"lsof")))
					  add_line_table = FALSE;
				  
			  if (add_line_table == TRUE)
				{
					ADD_ROW /* layout 1 */
					FILL_ROW
					append_num++;
					
					chk_command_list_add_row (); /* layout 2 */
					FILL_ROW2
				}
		  }
		  
	      print = FALSE;
	      memset (readbuf3, 0, sizeof (readbuf3));
	      for (i = 0; i < 12; i++)
			strcpy (&readbuf3[i][0], &readbuf2[i][0]);
	      for (i = 5; i < 12; i++)
			memset (readbuf2[i], 0, sizeof (readbuf2[i]));
	    } /* _if (print) */
			
	  memset (readbuf, 0, sizeof (readbuf));
			
	} /* _while */
	
  /*******************************/
  /*     OUT FROM MAIN LOOP      */
  /*******************************/
	
  if (strlen(readbuf) == 0)
	  if ((strcmp (tcp[0],"glsof")) && (strcmp (tcp[0],"lsof")))
		  {
			  ADD_ROW /* layout 1 */
			  FILL_ROW 
			  append_num++;
			
			  chk_command_list_add_row (); /* layout 2 */
			  FILL_ROW2
		  }
		  
  fclose (fp);
	
	if ((gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM (save_at_refresh1))) && (!timeout_id))
    {
		if (first_save_at_refresh_call)
		{
			first_save_at_refresh_call=FALSE;
			on_save_as_clicked (NULL,GINT_TO_POINTER(3));
		}
		else 
			on_ok_button1_clicked (NULL,GINT_TO_POINTER(3));

	}
	else
		first_save_at_refresh_call=TRUE;
  
  /* command list names : focus first line*/
  
  if ( (list_command_name->len > 0) && (GTK_WIDGET_VISIBLE(hpaned)) )
		gtk_widget_grab_focus (GTK_WIDGET (view_left_command_column));
	
  /* close splash screen after 1 second */
	
  if (tmp_check_show_splash_conf == FALSE)
	  timeout_splash_window = gtk_timeout_add( 1000, close_splash_window, NULL );
  
  /* show number of processes and lines in status bar */
  
  gtk_statusbar_pop (GTK_STATUSBAR(statusbar),1);
  g_snprintf(readbuf, BUFSIZ, "%d Processes\t%d Lines",list_command_name->len,append_num);
  gtk_statusbar_push (GTK_STATUSBAR (statusbar), 1, &readbuf[0]);

}
